summaryrefslogtreecommitdiff
path: root/usr.bin/cpp
diff options
context:
space:
mode:
authorTheo de Raadt <deraadt@cvs.openbsd.org>1996-01-02 13:49:08 +0000
committerTheo de Raadt <deraadt@cvs.openbsd.org>1996-01-02 13:49:08 +0000
commite79cf6bc9fac8b690adc55888a48f7aab45393ba (patch)
tree480368a53ea0edf93f3b7b6969e1e113e9e60cfe /usr.bin/cpp
parent1b3310acaaa89db89fd116595d1f3a59d2868594 (diff)
/usr/bin/cpp wrapper script (which now knows where to find the
correct path to GNU cpp through an incredibly twisted hack)
Diffstat (limited to 'usr.bin/cpp')
-rw-r--r--usr.bin/cpp/Makefile9
-rw-r--r--usr.bin/cpp/cpp.sh102
2 files changed, 111 insertions, 0 deletions
diff --git a/usr.bin/cpp/Makefile b/usr.bin/cpp/Makefile
new file mode 100644
index 00000000000..844fed8d4d4
--- /dev/null
+++ b/usr.bin/cpp/Makefile
@@ -0,0 +1,9 @@
+# $Id: Makefile,v 1.1 1996/01/02 13:49:07 deraadt Exp $
+
+NOMAN=
+
+beforeinstall:
+ install ${COPY} -o ${BINOWN} -g ${BINGRP} -m ${BINMODE} \
+ ${.CURDIR}/cpp.sh ${DESTDIR}${BINDIR}/cpp
+
+.include <bsd.prog.mk>
diff --git a/usr.bin/cpp/cpp.sh b/usr.bin/cpp/cpp.sh
new file mode 100644
index 00000000000..103e7ecc0d5
--- /dev/null
+++ b/usr.bin/cpp/cpp.sh
@@ -0,0 +1,102 @@
+#!/bin/sh
+#
+# Copyright (c) 1990 The Regents of the University of California.
+# All rights reserved.
+#
+# This code is derived from software contributed to Berkeley by
+# the Systems Programming Group of the University of Utah Computer
+# Science Department.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+# 3. All advertising materials mentioning features or use of this software
+# must display the following acknowledgement:
+# This product includes software developed by the University of
+# California, Berkeley and its contributors.
+# 4. Neither the name of the University nor the names of its contributors
+# may be used to endorse or promote products derived from this software
+# without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# @(#)usr.bin.cpp.sh 6.5 (Berkeley) 4/1/91
+#
+# Transitional front end to CCCP to make it behave like (Reiser) CCP:
+# specifies -traditional
+# doesn't search gcc-include
+#
+PATH=/usr/bin:/bin
+ALST="-traditional -D__GNUC__ -$ "
+NSI=no
+OPTS=""
+INCS="-nostdinc"
+FOUNDFILES=no
+
+CPP=/usr/libexec/cpp
+if [ ! -x $CPP ]; then
+ CPP=`cc -print-libgcc-file-name | sed -e 's/libgcc\.a/cpp/'`;
+fi
+
+while [ $# -gt 0 ]
+do
+ A="$1"
+ shift
+
+ case $A in
+ -nostdinc)
+ NSI=yes
+ ;;
+ -traditional)
+ ;;
+ -I*)
+ INCS="$INCS $A"
+ ;;
+ -U__GNUC__)
+ ALST=`echo $ALST | sed -e 's/-D__GNUC__//'`
+ ;;
+ -imacros|-include|-idirafter|-iprefix|-iwithprefix)
+ INCS="$INCS '$A' '$1'"
+ shift
+ ;;
+ -*)
+ OPTS="$OPTS '$A'"
+ ;;
+ *)
+ FOUNDFILES=yes
+ if [ $NSI = "no" ]
+ then
+ INCS="$INCS -I/usr/include"
+ NSI=skip
+ fi
+ eval $CPP $ALST $INCS $OPTS $A || exit $?
+ ;;
+ esac
+done
+
+if [ $FOUNDFILES = "no" ]
+then
+ # read standard input
+ if [ $NSI = "no" ]
+ then
+ INCS="$INCS -I/usr/include"
+ fi
+ eval exec $CPP $ALST $INCS $OPTS
+fi
+
+exit 0